<%@ Assembly Name="Microsoft.SharePoint, Version=14.0.0.0, Culture=neutral, PublicKeyToken=71e9bce111e9429c" %>
<%@ Page Language="C#" Inherits="Microsoft.SharePoint.WebPartPages.WikiEditPage" MasterPageFile="~masterurl/default.master" %>
<%@ Register TagPrefix="SharePoint" Namespace="Microsoft.SharePoint.WebControls" Assembly="Microsoft.SharePoint, Version=14.0.0.0, Culture=neutral, PublicKeyToken=71e9bce111e9429c" %>
<%@ Import Namespace="Microsoft.SharePoint" %>
<asp:Content ContentPlaceHolderID='PlaceHolderPageTitle' runat='server'>
    CSR Configuration
</asp:Content>
<asp:Content ContentPlaceHolderID='PlaceHolderPageTitleInTitleArea' runat='server'>
    CSR Configuration
</asp:Content>
<asp:Content ContentPlaceHolderID='PlaceHolderAdditionalPageHead' runat='server'>
    <meta name='CollaborationServer' content='SharePoint Team Web Site' />
    <!--
    @copyright 2016-2018 Joe McShea
    @license under the MIT license:
        http://www.opensource.org/licenses/mit-license.php
    -->
    <script type="text/javascript" src="jquery.js"></script>
    <script type="text/javascript" src="jquery-ui.js"></script>
    <script type="text/javascript" src="Intellipoint_ClientTemplatesConfig.js"></script>
    <script type="text/javascript" src="Intellipoint_ClientTemplates.js"></script>
    <link href="jquery-ui.css" rel="stylesheet" type="text/css">
    <style type="text/css">
        .nobr {
            white-space: nowrap;
        }

        #DeltaPageStatusBar {
            display: none;
        }

        .csr-fields {
            width: 700px;
            margin-bottom: 20px;
        }

        th.name,
        th.display {
            width: 300px;
        }

        th.type {
            width: 180px;
        }

        th.delete {
            width: 20px;
        }

        .ui-icon-closethick {
            cursor: pointer;
        }

        .ui-widget {
            font-size: .9em !important;
        }

        .ui-button {
            margin: 15px 0;
        }

        .formtable {
            margin: 20px;
        }

        #content {
            display: none;
        }

        .input input {
            margin: 5px;
            width: 300px;
        }

        .ui-icon-disabled {
            opacity: .2;
        }

        .ui-icon-pencil:not(.ui-icon-disabled) {
            cursor: pointer;
        }

        .ui-icon-cell {
            width: 40px;
        }

        .ui-icon-cell .ui-icon {
            display: inline-block;
        }
    </style>
</asp:Content>
<asp:Content ContentPlaceHolderID='PlaceHolderMiniConsole' runat='server'>
    <SharePoint:FormComponent TemplateName='WikiMiniConsole' ControlMode='Display' runat='server' id='WikiMiniConsole'></SharePoint:FormComponent>
</asp:Content>
<asp:Content ContentPlaceHolderID='PlaceHolderLeftActions' runat='server'>
    <SharePoint:RecentChangesMenu runat='server' id='RecentChanges'></SharePoint:RecentChangesMenu>
</asp:Content>
<asp:Content ContentPlaceHolderID='PlaceHolderMain' runat='server'>
    <div id="content">
        <h3>Add a Client Template</h3>
        <table class="formtable">
            <tr>
                <td>CSR Type: </td>
                <td>
                    <select id="csrType">
                        <option></option>
                    </select>
                </td>
            </tr>
            <tr>
                <td>Field: </td>
                <td>
                    <select id="field">
                        <option></option>
                    </select>
                </td>
            </tr>
            <tr>
                <td></td>
                <td>
                    <button id="addCsr" type="button">Add Client Template</button>
                    <button id="save" type="button">Save</button>
                </td>
            </tr>
        </table>
        <div id="templateImplTables"></div>
    </div>
    <div id="dialogs" style="display:none"></div>
    <script type="text/javascript">
        (function ($) {

            ////////////////////////////////////////////////////////////////////////////////
            // Code in fron class for the form.
            ////////////////////////////////////////////////////////////////////////////////
            var templateConfigSetter = {
                toDelete: [],
                parsedFields: {},

                ////////////////////////////////////////////////////////////////////////////////
                // Main entry point, needs to be called after SharePoint context is prepared.
                ////////////////////////////////////////////////////////////////////////////////
                init: function () {
                    // initialize the client context
                    templateConfigSetter.initClientContext(function () {
                        // load the site columns
                        templateConfigSetter.fields = templateConfigSetter.web.get_availableFields();
                        templateConfigSetter.clientContext.load(templateConfigSetter.fields);

                        // exec the query async
                        templateConfigSetter.clientContext.executeQueryAsync(
                            function () {
                                // on success enumerate the fields and initialize the form controls
                                templateConfigSetter.enumerateFields();

                                // for each template implementation, add an option to the csrType select, and display the current configuration
                                $.each(Object.keys(IntelliPoint.clientTemplates).sort(), function (i, templateName) {
                                    var templateImpl = IntelliPoint.clientTemplates[templateName];
                                    $("#csrType").append($("<option/>", { "value": templateName }).text(templateImpl.displayName));
                                    templateConfigSetter.drawTemplateTable(templateImpl);
                                });

                                // when the csr type select changes, change the select of available fields for that the new type
                                templateConfigSetter.wireCsrTypeSelect();

                                // when the field select changes, enable/disable the add button
                                templateConfigSetter.wireFieldSelect();

                                // when clicked, add a row to the appropriate table and clear selects 
                                templateConfigSetter.wireAddButton();

                                // when clicked, post the Intellipoint_ClientTemplatesConfig.js file and clear selects
                                templateConfigSetter.wireSaveButton();

                                // when clicked, edit implementation-specific configuration
                                templateConfigSetter.wireEditButtons();

                                // when clicked, remove the table row
                                templateConfigSetter.wireDeleteButtons();

                                $("#content").show();
                            },
                            function () {
                                alert("Could not load site columns.");
                            }
                        );
                    });
                },

                isInConfig: function (name) {
                    var result = false;
                    $.each(Object.keys(IntelliPoint.clientTemplatesConfig), function (i, v) {
                        var config = IntelliPoint.clientTemplatesConfig[v];
                        var index = templateConfigSetter.indexOfObjectWithPropertyValue(config, "internalName", name);
                        if (index > -1) {
                            result = true;
                            return false;
                        }
                        return true;
                    });
                    return result;
                },

                ////////////////////////////////////////////////////////////////////////////////
                // When the csr type is changed, change options in the field select so that 
                // only fields appropriate to the current csr type are available.
                ////////////////////////////////////////////////////////////////////////////////
                wireCsrTypeSelect: function () {
                    $("#csrType").change(function (e) {
                        templateConfigSetter.initCsrTypeSelect();
                        $("#addCsr").button("option", "disabled", false);
                    });
                },

                ////////////////////////////////////////////////////////////////////////////////
                // When the current field changes, enable/disable the add button.
                ////////////////////////////////////////////////////////////////////////////////
                wireFieldSelect: function () {
                    $("#field").change(function (e) {
                        if (e.target.value.length > 0) {
                            $("#addCsr").button("option", "disabled", false);
                        }
                        else {
                            $("#addCsr").button("option", "disabled", true);
                        }
                    });
                },

                ////////////////////////////////////////////////////////////////////////////////
                // Add a row to the appropriate table, and a configuration node to the template config.
                ////////////////////////////////////////////////////////////////////////////////
                wireAddButton: function () {
                    $("#addCsr").button({
                        icons: {
                            primary: "ui-icon-plus"
                        },
                        text: true
                    }).click(function () {
                        var templateImpl = IntelliPoint.clientTemplates[$("#csrType").val()];

                        // call the implementation's configure method
                        templateImpl.configure($("#field").val(), null, function (node) {
                            // when it calls it back, node is the full configuration

                            // get the parsed field
                            var v = templateConfigSetter.parsedFields[node.internalName];

                            // add the new node to the configuration
                            var fields = IntelliPoint.clientTemplatesConfig[templateImpl.name];
                            fields.push(node);

                            // if the internal name is in toDelete, remove it since we're adding it back
                            var deleteIndex = $.inArray(v.name, templateConfigSetter.toDelete);
                            if (deleteIndex > -1) {
                                templateConfigSetter.toDelete.splice(deleteIndex, 1);
                            }

                            // find the impl table and append a row for the new configuration node
                            var $table = $("#" + templateImpl.name + "Table");
                            var $row = $("<tr/>", { "class": "config" });
                            $row.append(($("<td/>", { "class": "ui-widget-content ui-corner-all nobr" }).html(v.name)));
                            $row.append(($("<td/>", { "class": "ui-widget-content ui-corner-all nobr" }).html(v.displayName)));
                            $row.append(($("<td/>", { "class": "ui-widget-content ui-corner-all nobr" }).html(v.type)));
                            var editBtn = $("<span class='ui-button-icon-primary ui-icon ui-icon-pencil' title='Edit'></span>");
                            if (!templateImpl.canEdit) editBtn.addClass("ui-icon-disabled");
                            var closeBtn = $("<span class='ui-button-icon-primary ui-icon ui-icon-closethick' title='Delete'></span>");
                            $row.append($("<td/>").addClass("ui-icon-cell").append(editBtn).append(closeBtn));
                            $table.append($row);
                            $table.find("tr.empty").remove();

                            // update button states and other controls
                            $("#save").button("option", "disabled", false);
                            templateConfigSetter.initCsrTypeSelect();
                        });
                    });

                },

                ////////////////////////////////////////////////////////////////////////////////
                // Edit and existing node in the template config, nothing to update in the UI.
                ////////////////////////////////////////////////////////////////////////////////
                wireEditButtons: function () {
                    $(".csr-fields").on("click", ".ui-icon-pencil:not(.ui-icon-disabled)", function (e) {
                        var span = $(e.target);
                        var table = span.closest("table");
                        var tr = span.closest("tr");

                        // the table name is the template implementation name with Table appended
                        var templateName = table[0].id.replace("Table", "");
                        // get the template implementation
                        var templateImpl = IntelliPoint.clientTemplates[templateName];
                        // the first td contains the internal name of the field
                        var name = $(tr.children()[0]).text();

                        // find the index of the name in the config and get the node
                        var index = templateConfigSetter.indexOfObjectWithPropertyValue(
                            IntelliPoint.clientTemplatesConfig[templateName],
                            "internalName",
                            name);
                        var config = IntelliPoint.clientTemplatesConfig[templateName][index];

                        // call the template configure method and let it reconfigure the node
                        templateImpl.configure(name, config, function (node) {
                            IntelliPoint.clientTemplatesConfig[templateName][index] = node;
                            $("#save").button("option", "disabled", false);
                        });
                    });
                },

                ////////////////////////////////////////////////////////////////////////////////
                // Delete a row from one of the configuration tables, and from the template config.
                ////////////////////////////////////////////////////////////////////////////////
                wireDeleteButtons: function () {
                    $(".csr-fields").on("click", ".ui-icon-closethick", function (e) {
                        var span = $(e.target);
                        var table = span.closest("table");
                        var tr = span.closest("tr");

                        // the table name is the template implementation name with Table appended
                        var templateName = table[0].id.replace("Table", "");
                        // the first td contains the internal name of the field
                        var name = $(tr.children()[0]).text();

                        // find the name in the config, and delete it from the config
                        var index = templateConfigSetter.indexOfObjectWithPropertyValue(
                            IntelliPoint.clientTemplatesConfig[templateName],
                            "internalName",
                            name);
                        IntelliPoint.clientTemplatesConfig[templateName].splice(index, 1);

                        // find the row and field name, add the name to toDelete, and delete the row.
                        if ($.inArray(name, templateConfigSetter.toDelete) < 0) {
                            templateConfigSetter.toDelete.push(name);
                        }
                        tr.remove();

                        // if the table is now empty, add a row with an empty message
                        if (table.find("td").length === 0) {
                            table.append((
                                $("<tr/>", { "class": "empty" }).html(
                                    "<td class='ui-widget-content ui-corner-all nobr' colspan='3'>There currently are no fields configured to use this template.</td>")
                            ));
                        }

                        $("#save").button("option", "disabled", false);
                        templateConfigSetter.initCsrTypeSelect();
                    });
                },

                ////////////////////////////////////////////////////////////////////////////////
                // Post the configuration back to /Style Library/Intellipoint_ClientTemplatesConfig.js.
                ////////////////////////////////////////////////////////////////////////////////
                wireSaveButton: function () {
                    $("#save").button({
                        icons: {
                            primary: "ui-icon-disk"
                        },
                        text: true
                    }).click(function () {
                        // construct the contents of the file
                        var contents = "window.IntelliPoint = window.IntelliPoint || {};\n";
                        contents += "IntelliPoint.clientTemplatesConfig = " + JSON.stringify(IntelliPoint.clientTemplatesConfig, null, 4) + "\n";
                        contents = contents.replace(/\r?\n/g, "\r\n");

                        // write the file back to SharePoint, overwriting if it already exists
                        $.ajax({
                            url: templateConfigSetter.siteRelativePathAsAbsolutePath("/Style Library/Intellipoint_clientTemplatesConfig.js"),
                            type: "PUT",
                            headers: {
                                "Content-Type": "text/plain",
                                "Overwrite": "T"
                            },
                            data: contents,
                            success: function () {
                                $("#save").button("option", "disabled", true);
                                templateConfigSetter.injectScripts();
                                alert("Successfully saved the configuration.");
                            },
                            error: templateConfigSetter.error
                        });
                    });
                    $("#save").button("option", "disabled", true);
                },

                ////////////////////////////////////////////////////////////////////////////////
                // Populate the field select with options. One option for each field that is
                // of a type that the current template implementation can support, minuse any
                // fields that are already configured to use a template implementation.
                ////////////////////////////////////////////////////////////////////////////////                                
                initCsrTypeSelect: function () {
                    $("#field").html("<option></option>");
                    var implType = $("#csrType").val();
                    if (implType.length > 0) {
                        // if the select type is not blank
                        var templateImpl = IntelliPoint.clientTemplates[implType];
                        if (typeof (templateImpl) !== "undefined") {
                            // if we have an implementation for the type
                            $.each(templateConfigSetter.parsedFields, function (i, v) {
                                // for each parsed field
                                if ($.inArray(v.type, templateImpl.types) > -1 &&
                                    !templateConfigSetter.isInConfig(v.name)) {
                                    // if the field type matches one of the allowed imlmenentation types, 
                                    // and the field is not in IntelliPoint.clientTemplatesConfig (i.e. already configured),
                                    // add it to the fields dropdown
                                    $("#field").append(
                                        "<option value='" + v.name + "'>" + v.displayName + " [" + v.name + "]" + "</option>");
                                }
                            });
                        }
                    }
                    $("#addCsr").button("option", "disabled", true);
                },

                ////////////////////////////////////////////////////////////////////////////////
                // Setup the JSLink required for the currently configured fields. This includes
                // deleting the JSLink from fields in the toDelete array.
                ////////////////////////////////////////////////////////////////////////////////
                injectScripts: function () {
                    // get a map of field names to arrays of JSLink JavaScript files
                    var jsLink = templateConfigSetter.getScripts();

                    // load all of the fields we want to set JSLink on
                    var fields = {};
                    $.each(Object.keys(jsLink), function (i, key) {
                        fields[key] = templateConfigSetter.web.get_availableFields().getByInternalNameOrTitle(key);
                        templateConfigSetter.clientContext.load(fields[key]);
                    });

                    // load all of the fields we want to delete JSLink from
                    $.each(templateConfigSetter.toDelete, function (i, name) {
                        fields[name] = templateConfigSetter.web.get_availableFields().getByInternalNameOrTitle(name);
                        templateConfigSetter.clientContext.load(fields[name]);
                    });

                    // get all fields async
                    templateConfigSetter.clientContext.executeQueryAsync(function () {
                        // set the JSLink on all fields
                        $.each(Object.keys(jsLink), function (i, key) {
                            var scripts = jsLink[key].join("|");
                            fields[key].set_jsLink(scripts);
                            fields[key].updateAndPushChanges(true);
                        });

                        // blank out the JSLink on all toDelete fields
                        $.each(templateConfigSetter.toDelete, function (i, name) {
                            fields[name].set_jsLink("");
                            fields[name].updateAndPushChanges(true);
                        });

                        // execute all JSLink changes at once, async
                        templateConfigSetter.clientContext.executeQueryAsync(function () {
                            templateConfigSetter.toDelete = []; // reset toDelete
                        }, templateConfigSetter.error);
                    }, templateConfigSetter.error);
                },

                ////////////////////////////////////////////////////////////////////////////////
                // Return a map of field internal names to JSLink for each field currently configure.
                ////////////////////////////////////////////////////////////////////////////////
                getScripts: function () {
                    var result = {};
                    // loop through each template implementation
                    $.each(Object.keys(IntelliPoint.clientTemplates), function (i, templateName) {
                        var templateConfig = IntelliPoint.clientTemplatesConfig[templateName];
                        var templateImpl = IntelliPoint.clientTemplates[templateName];

                        // if the template has fields configured
                        if (templateConfig.length > 0) {
                            // loop through the fields
                            $.each($(templateConfig), function (j, field) {
                                // map the field internal name to the jsLink of the template
                                result[field.internalName] = templateImpl.jsLink;
                            });
                        }
                    });
                    return result;
                },

                ////////////////////////////////////////////////////////////////////////////////
                // Construct and inject a single configuration table into the DOM for a single
                // CSR template.
                ////////////////////////////////////////////////////////////////////////////////
                drawTemplateTable: function (templateImpl) {
                    var $div = $("#templateImplTables");

                    // create a header and table
                    $div.append($("<h3/>").text(templateImpl.displayName + " Fields"));
                    var $table = $("<table/>", { "id": templateImpl.name + "Table", "class": "csr-fields" });
                    $div.append($table);

                    // create the header row
                    var $headers = $("<tr/>");
                    $headers.append($("<th/>", { "class": "name ui-widget-header ui-corner-all nobr" }).text("Internal Name"));
                    $headers.append($("<th/>", { "class": "displayname ui-widget-header ui-corner-all nobr" }).text("Display Name"));
                    $headers.append($("<th/>", { "class": "type ui-widget-header ui-corner-all nobr" }).text("Field Type"));
                    $headers.append($("<th/>", { "class": "delete" }));
                    $table.append($headers);

                    // sort the template configuration by internal name
                    var templateConfig = IntelliPoint.clientTemplatesConfig[templateImpl.name].sort(function (a, b) {
                        if (a.internalName < b.internalName)
                            return -1;
                        if (a.internalName > b.internalName)
                            return 1;
                        return 0;
                    });

                    // loop through and create a row for each field in the template configuration
                    $.each($(templateConfig), function (i, k) {
                        var v = templateConfigSetter.parsedFields[k.internalName];
                        if (typeof (v) !== "undefined") {
                            var $row = $("<tr/>", { "class": "config" });
                            $row.append(($("<td/>", { "class": "ui-widget-content ui-corner-all nobr" }).html(v.name)));
                            $row.append(($("<td/>", { "class": "ui-widget-content ui-corner-all nobr" }).html(v.displayName)));
                            $row.append(($("<td/>", { "class": "ui-widget-content ui-corner-all nobr" }).html(v.type)));
                            var editBtn = $("<span class='ui-button-icon-primary ui-icon ui-icon-pencil' title='Edit'></span>");
                            if (!templateImpl.canEdit) editBtn.addClass("ui-icon-disabled");
                            var closeBtn = $("<span class='ui-button-icon-primary ui-icon ui-icon-closethick' title='Delete'></span>");
                            $row.append($("<td/>").addClass("ui-icon-cell").append(editBtn).append(closeBtn));
                            $table.append($row);
                        }
                    });

                    // if no fields are configured, add a row with an empty message
                    if ($table.find("td").length === 0) {
                        $table.append((
                            $("<tr/>", { "class": "empty" }).html("<td class='ui-widget-content ui-corner-all nobr' colspan='3'>There currently are no fields configured to use this template.</td>")
                        ));
                    }
                },

                ////////////////////////////////////////////////////////////////////////////////
                // Enumerate the site columns and store information about them.
                ////////////////////////////////////////////////////////////////////////////////
                enumerateFields: function () {
                    // enuerate the fields into a tmp array
                    var enumerator = templateConfigSetter.fields.getEnumerator();
                    var arr = [];
                    while (enumerator.moveNext()) {
                        var current = enumerator.get_current();
                        var tmp = {};
                        tmp.name = current.get_internalName();
                        tmp.displayName = current.get_title();
                        tmp.type = current.get_typeAsString();
                        tmp.jslink = current.get_jsLink();
                        tmp.hidden = current.get_hidden();
                        if (!tmp.hidden) {
                            arr.push(tmp);
                        }
                    }

                    // sort the array
                    arr = arr.sort(function (a, b) {
                        if (a.displayName < b.displayName)
                            return -1;
                        if (a.displayName > b.displayName)
                            return 1;
                        return 0;
                    });

                    // convert the array into the parseFields map
                    $.each(arr, function (i, v) {
                        templateConfigSetter.parsedFields[v.name] = v;
                    });
                },

                ////////////////////////////////////////////////////////////////////////////////
                // Initialize the sharepoint object model, meaning site and web. The callbacks
                // are passed in case I also want to initialize something else asynchronously.
                ////////////////////////////////////////////////////////////////////////////////
                initClientContext: function (success, failure) {
                    if (!templateConfigSetter.clientContext) {
                        templateConfigSetter.clientContext = new SP.ClientContext();

                        if (!templateConfigSetter.site) {
                            templateConfigSetter.site = templateConfigSetter.clientContext.get_site();
                        }

                        if (!templateConfigSetter.web) {
                            templateConfigSetter.web = templateConfigSetter.clientContext.get_web();
                        }

                        success();
                    }
                    else {
                        success();
                    }
                },

                ////////////////////////////////////////////////////////////////////////////////
                // Failure callback for all async calls.
                ////////////////////////////////////////////////////////////////////////////////
                error: function (sender, args) {
                    alert('Request failed. ' + args.get_message() + '\n' + args.get_stackTrace());
                },

                ////////////////////////////////////////////////////////////////////////////////
                // Helper to find the index of an object in an array of objects by property value.
                ////////////////////////////////////////////////////////////////////////////////
                indexOfObjectWithPropertyValue: function (arrayOfObjects, objectProperyName, value) {
                    for (var i = 0; i < arrayOfObjects.length; i += 1) {
                        if (arrayOfObjects[i][objectProperyName] === value) {
                            return i;
                        }
                    }
                    return -1;
                },

                ////////////////////////////////////////////////////////////////////////////////
                // Utility method to conver a site relative path to an absolute path. i.e.
                // converts 'Style Library/Intellipoint_ClientTemplatesConfig.js' => 
                // '/sites/yoursite/Style Library/Intellipoint_ClientTemplatesConfig.js.js'.
                // Seems pretty simple, but if you're in the root web of a host named site collection,
                // or at the root of the web application, and your not careful,
                // you could be sorry.
                ////////////////////////////////////////////////////////////////////////////////
                siteRelativePathAsAbsolutePath: function (path) {
                    var site = _spPageContextInfo.siteServerRelativeUrl;
                    if (path[0] !== '/') {
                        path = '/' + path;
                    }
                    if (site !== '/') {
                        path = site + path;
                    }
                    return path;
                }
            };

            SP.SOD.executeFunc("sp.js", "SP.ClientContext", function () {
                templateConfigSetter.init();
            });
        })(jQuery);
    </script>
</asp:Content>